- AC-branch is gone. rest well
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
d54662bf
AF
1# PLD rpm macros
2
e05017c1 3%epoch 0
3241033b 4%x8664 x86_64 amd64 ia32e
9c404149 5
ba1fdedc 6# kernel compiler
d2e1bc22 7%kgcc gcc
8%kgcc_package gcc
ba1fdedc 9
3241033b
ER
10%_source_payload w9.gzdio
11%_binary_payload w9.bzdio
12
33040789 13# Build system path macros.
14#
bddadece
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
f93109a0 17%__autopoint autopoint --force
18
83094b62 19%__gettextize { \
3241033b 20if ! gettextize --version | grep -q '0\.10\.' ; then \
8a995cff 21 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 22 gettextize --copy --force --no-changelog; \
97589b6e 23 else \
3241033b 24 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
25 fi; \
26 if [ ! -f po/Makevars ]; then \
3241033b 27 cp -f po/Makevars{.template,}; \
8a995cff 28 fi; \
3241033b 29else \
8a995cff 30 gettextize --copy --force; \
3241033b 31fi; \
8a995cff 32}
f93109a0 33
34%__glib_gettextize glib-gettextize --copy --force
35%__gnome_doc_common gnome-doc-common --copy
36%__gtkdocize gtkdocize --copy
37%__intltoolize intltoolize --copy --force
38%__libtoolize libtoolize --copy --force
33040789 39
6a5eda77 40%dependencytracking %{nil}
3241033b 41
9c404149 42#-----------------------------------------------------------------
9f4ce098 43%configure2_13 { \
9c404149
AM
44 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
45 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
46 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 47 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 48 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
8ec1a12b 49 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
8983c4c4
AM
50 %{?__cc:CC="%{__cc}" ; export CC ; } \
51 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 52 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 53 --host=%{_target_platform} \
9c404149
AM
54 --prefix=%{_prefix} \
55 --exec-prefix=%{_exec_prefix} \
56 --bindir=%{_bindir} \
57 --sbindir=%{_sbindir} \
58 --sysconfdir=%{_sysconfdir} \
59 --datadir=%{_datadir} \
60 --includedir=%{_includedir} \
61 --libdir=%{_libdir} \
62 --libexecdir=%{_libexecdir} \
63 --localstatedir=%{_localstatedir} \
64 --sharedstatedir=%{_sharedstatedir} \
65 --mandir=%{_mandir} \
66 --infodir=%{_infodir} \
c0d1b3ad 67 --x-libraries=/usr/X11R6/%{_lib} \
93059874 68 %{dependencytracking} \
9c404149
AM
69}
70
4a6b0d54 71#----------------------------------------------------------------
73f832b3 72%global configure_cache 0
73%configure_cache_file %{buildroot}.configure.cache
74
57f4166d 75%configure {./configure \
4a6b0d54
AF
76 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
77 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 78 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 79 FFLAGS="${FFLAGS:-%rpmcflags}" \
a2bd5992 80 CPPFLAGS="${CPPFLAGS:-}" \
8983c4c4
AM
81 %{?__cc:CC="%{__cc}"} \
82 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 83 --host=%{_target_platform} \
4a6b0d54
AF
84 --build=%{_target_platform} \
85 --prefix=%{_prefix} \
86 --exec-prefix=%{_exec_prefix} \
87 --bindir=%{_bindir} \
88 --sbindir=%{_sbindir} \
89 --sysconfdir=%{_sysconfdir} \
90 --datadir=%{_datadir} \
91 --includedir=%{_includedir} \
92 --libdir=%{_libdir} \
93 --libexecdir=%{_libexecdir} \
94 --localstatedir=%{_localstatedir} \
95 --sharedstatedir=%{_sharedstatedir} \
96 --mandir=%{_mandir} \
97 --infodir=%{_infodir} \
c0d1b3ad 98 --x-libraries=/usr/X11R6/%{_lib} \
93059874 99 %{dependencytracking} \
73f832b3 100 %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
4a6b0d54
AF
101}
102
7dbab518 103# ------------------------------------------------------------------------
c80506a3
AM
104# Overloading of some basic macros
105%prep \
106%%prep\
107LANG=C\
108export LANG\
14e77e64 109unset DISPLAY ||:\
6db5639d 110unset LINGUAS ||:\
c80506a3
AM
111%{nil}
112
113%build %%build\
114LANG=C\
115export LANG\
14e77e64 116unset DISPLAY ||:\
6db5639d 117unset LINGUAS ||:\
c80506a3
AM
118%{nil}
119
b4e3d367
ER
120%install \
121%if 0%{?_enable_debug_packages}\
122%{?buildsubdir:%{debug_package}}\
123%endif\
c80506a3
AM
124%%install\
125LANG=C\
126export LANG\
14e77e64 127unset DISPLAY ||:\
6db5639d 128unset LINGUAS ||:\
c80506a3
AM
129%{nil}
130
9c404149
AM
131# Location of autoconf macros
132%_aclocaldir %(aclocal --print-ac-dir)
133
e2804f99
AM
134# Location of omf files
135%_omf_dest_dir %(scrollkeeper-config --omfdir)
136
e987a186 137# Location of pkgconfig files
9a4e877a 138%_pkgconfigdir /usr/%{_lib}/pkgconfig
e987a186 139
486b0b5f 140# Location of desktop files
141%_desktopdir /usr/share/applications
86dff2d0 142%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 143
481463e9 144# Location of pixmaps for applnk/desktop files
e1f0a822 145%_pixmapsdir /usr/share/pixmaps
9c404149 146
481463e9 147# Location of themable icons for applnk/desktop files
b36c8e2a 148%_iconsdir /usr/share/icons
149
e987a186
JB
150# Location of fonts directories
151%_fontsdir /usr/share/fonts
152
b3282f3f 153# Location of Gtk and associated libraries documentation
6eed6d84 154%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 155
fc4d7771 156# Location of KDE documentation
157%_kdedocdir %{_defaultdocdir}/kde/HTML
158
5869828c 159# unsermake script
160%__unsermake /usr/share/unsermake/unsermake
161
9c404149
AM
162# Current date
163%date %(LC_ALL="C" date +"%a %b %d %Y")
164
165# tmp directory
166%tmpdir %(echo "${TMPDIR:-/tmp}")
167
168# Example files, programs, scripts...
169%_examplesdir /usr/src/examples
170
8377d27d 171# The directory holding Linux kernel sources
172%_kernelsrcdir /usr/src/linux
173
9c404149 174# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 175%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 176
8f74418b 177# Requires name = version-release
ec4e8b11 178%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
8bf3719d 179
c12095e9
PS
180%releq_kernel_up() %(LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
181%releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
182%requires_releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
183%requires_releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
8bf3719d 184
16cb1d91 185%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
01a9f990 186
179fcc7f 187%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
b9d5d440 188
189# kernel version-release handling
3241033b
ER
190%__kernel_ver %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
191%__kernel_rel %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
f004e915 192%__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
3241033b 193%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
f62e856d 194%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
87be1cf0 195
e00dd7f6 196# sgml macros
3241033b
ER
197%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
198%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
199%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
200%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
201%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
202%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 203%docbook_sgmlcat_fix() { for l in \
204'' \
205' -- default decl --' \
206'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
207' -- hacks for opensp --' \
208'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
209'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
210'' \
211; do echo $l; done >> %1 \
212}
213
9c404149
AM
214#-----------------------------------------------------------------
215# find and gzip all files in %{_mandir} and %{infodir}
216#
217# Requires: xargs, find
218#
219#%no_install_post_compress_docs 1
220%__spec_install_post_compress_docs { \
9c404149 221%{!?no_install_post_compress_docs: \
822d4d81 222 echo "Compress man and info pages."; \
9c404149
AM
223 %{?verbose:set -x;} \
224 for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
225 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
226 find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
227 find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
228 find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
229 fi; \
230 done; \
231} }
232
233#-----------------------------------------------------------------
234# Strip executable binaries and shared object files
235#
236# Requires: find, awk, strip, cut, xargs
237#
238#%no_install_post_strip 1
239%__spec_install_post_strip {%{!?debug: \
240%{!?no_install_post_strip: \
3241033b
ER
241%{?verbose:set -x;} \
242 if [ -d "$RPM_BUILD_ROOT" ]; then \
8f74418b 243 echo "Strip executable binaries, archives and shared object files."; \
b4e3d367 244 filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
9c404149
AM
245 elfexelist=`echo $filelist | xargs -r file | \
246 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
247 elfsharedlist=`echo $filelist | xargs -r file | \
248 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
8f74418b
MM
249 elfarchiveslist=`echo $filelist | xargs -r file | \
250 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
9c404149 251 if [ -n "$elfexelist" ]; then \
60ad88f2 252 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
9c404149
AM
253 fi; \
254 if [ -n "$elfsharedlist" ]; then \
60ad88f2 255 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
8f74418b
MM
256 fi; \
257 if [ -n "$elfarchiveslist" ]; then \
60ad88f2 258 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
9f0d4f36 259 fi; \
3241033b 260fi; } \
9c404149 261} }
3241033b 262
fc5d7e20 263#-----------------------------------------------------------------
264# remove all RPATH from executable binaries and shared object files
265#
266# Requires: find, awk, cut, xargs, chrpath, uname
267#
268#%no_install_post_chrpath 1
269%__spec_install_post_chrpath {%{!?debug: \
270%{!?no_install_post_chrpath: \
271 %{?verbose:set -x;} \
9f0d4f36 272if [ -d "$RPM_BUILD_ROOT" ]; then \
fc5d7e20 273echo "Remove RPATH from executable binaries and shared object files."; \
adb39da4 274find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
5bed2bb7 275 awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
fc5d7e20 276while read file ; do \
277 rpath= ; \
278 chmod u+w "$file"; \
279 for dir in `chrpath -l "$file" | \
3241033b 280 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
fc5d7e20 281 case $dir in \
494e368c 282 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
fc5d7e20 283 echo "remove-rpath: $dir in $file"; \
284 ;; \
285 * ) \
286 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
287 else rpath="$rpath:$dir" ; fi ; \
288 ;; \
289 esac ; \
290 done ; \
291 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
292 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
9f0d4f36
JB
293done; \
294fi; } \
fc5d7e20 295} }
3241033b 296
d72c185f 297#-----------------------------------------------------------------
ccb8ae8d 298# Find and gzip all kernel modules
299#
300# Requires: find
301#
302#%no_install_post_compress_modules 1
303%__spec_install_post_compress_modules { \
ccb8ae8d 304%{!?no_install_post_compress_modules: \
3241033b
ER
305 %{?verbose:set -x;} \
306 if [ -d "$RPM_BUILD_ROOT" ]; then \
307 echo "Compress kernel modules if any."; \
308 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
309 find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
310 xargs -r %{__gzip} -9nf; \
311 find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
312 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
313 fi; \
314 fi; \
ccb8ae8d 315} }
9c404149 316
83094b62 317#-----------------------------------------------------------------
0e4cb4dd 318# Update GConf2 schemas
83094b62 319#
320# Requires: GConf2
321#
46885239 322%gconf_schema_install() \
3241033b
ER
323 umask 022; \
324 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
325 %{nil}
46885239 326
327%gconf_schema_uninstall() \
f93109a0 328if [ $1 = 0 ]; then \
3241033b
ER
329 umask 022; \
330 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f93109a0 331fi \
332%{nil}
333
334#-----------------------------------------------------------------
335# Update desktop MIME database
c0a4caa0 336# requires: desktop-file-utils
f93109a0 337#
820792a9 338%update_desktop_database_post() {{ \
f93109a0 339 umask 022; \
340 /usr/bin/update-desktop-database; \
4565b525 341}}
f93109a0 342
09e3522b 343%update_desktop_database_postun() {{ \
f93109a0 344if [ $1 = 0 ]; then \
345 umask 022; \
346 /usr/bin/update-desktop-database; \
347fi \
4565b525 348}}
f93109a0 349
350#-----------------------------------------------------------------
351# Update scrollkeeper database
352# requires: scrollkeeper
353#
354%scrollkeeper_update_post() \
f93109a0 355 /usr/bin/scrollkeeper-update -q; \
356 %{nil}
357
358%scrollkeeper_update_postun() \
359if [ $1 = 0 ]; then \
f93109a0 360 /usr/bin/scrollkeeper-update -q; \
361fi \
362%{nil}
363
364#-----------------------------------------------------------------
365# Run ldconfig after installing/deinstalling libraries
366#
367%ldconfig_post() \
368 /sbin/ldconfig; \
369 %{nil}
370
371%ldconfig_postun() \
f93109a0 372 /sbin/ldconfig; \
b430f866 373 %{nil}
83094b62 374
9c404149
AM
375#-----------------------------------------------------------------
376# post %install sequence:
377# - autodeps exceptions
378# - compress all man and info pages,
379# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 380# - compress kernel modules if any
9c404149
AM
381
382###################################################################
383# Requires/Provides automation
384# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
338726a6 385#
2892b5df
JB
386%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
387%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
388%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
389%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
390%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
338726a6
JB
391#%_noautocompressdoc %{nil}
392#
8f74418b
MM
393%_missing_doc_files_terminate_build 1%{nil}
394%_unpackaged_files_terminate_build %{nil}
8781dc74 395# (X)emacs support
d77dcb61 396%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
8781dc74
AF
397%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
398%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
25043cd4 399
02b58f60
JK
400%__php_provides %{nil}
401%__php_requires %{nil}
402%__perl_provides %{nil}
403%__perl_requires %{nil}
fa3497cd 404%__mono_provides %{nil}
405%__mono_requires %{nil}
25043cd4
AF
406
407# Perl specific macro definitions.
c853f847
AF
408%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
409%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
410%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
411%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
412%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
413%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
25043cd4 414
c853f847 415%php_pear_dir %{_datadir}/pear
25043cd4 416
c1b2705c
ER
417# directory where php includes are installed on system.
418%__php_includedir /usr/include/php
0c5d1b9b 419# extract php/zend api versions
e9b6395a 420%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
c1b2705c 421%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
68b68193 422%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
c1b2705c
ER
423%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
424%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
c0ac7203 425%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
c1b2705c
ER
426
427# helper macro
f952c0f3 428%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
429
430# macros for public use
431# for php extensions (php-pecl)
68b68193 432%requires_php_extension %{__php_api_requires modules_api php_api_version} \
f952c0f3
ER
433%{__php_api_requires -v %php_major_version debug php_debug} \
434%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 435
c1b2705c
ER
436# for zend extensions
437%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 438%{__php_api_requires zend_extension_api} \
f952c0f3
ER
439%{__php_api_requires -v %php_major_version debug php_debug} \
440%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 441
25043cd4
AF
442# Python specific macro definitions.
443# python main version
3241033b 444%py_ver %(python -c "import sys; print sys.version[:3]")
25043cd4
AF
445
446# directories
3241033b
ER
447%py_prefix %(python -c "import sys; print sys.prefix")
448%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 449%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 450%py_incdir /usr/include/python%{py_ver}
ef7ec0a8
JK
451%py_sitedir %{py_libdir}/site-packages
452%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 453%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
454
455# pure python modules compilation
3241033b 456%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 457
3241033b 458%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
459
460# Software written in Python language require Python with main version
e63cd81d 461%pyrequires_eq() Requires: %1
25043cd4 462
f12c2314
AF
463# Hardlink binary identical .pyc and .pyo files
464# (idea by glen <at> pld-linux <dot> org)
465%__spec_install_post_py_hardlink {\
d56b7e24 466%{!?no_install_post_py_hardlink: \
f12c2314
AF
467[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
468 b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
469 if cmp -s "$a" "$b"; then \
470 ln -f "$a" "$b"; \
471 fi; \
472done \
473} }
474
9227b3f9 475# remove python sources, so that check-files won't complain
f12c2314
AF
476# (idea by glen <at> pld-linux <dot> org)
477%py_postclean() \
0f82e280 478for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 479 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
480done \
481%{nil}
482
0fc5cff8 483# depmod macro
484%depmod() { \
f6148427 485umask 022; \
0fc5cff8 486if [ -e /boot/System.map-%1 ]; then \
3241033b 487 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 488else \
3241033b
ER
489 if [ -e /boot/System.map ]; then \
490 /sbin/depmod -a -F /boot/System.map %1; \
491 else \
492 /sbin/depmod -a %1; \
493 fi \
0fc5cff8 494fi; \
495}
496
2afc6e64 497# XMMS specific macros
3241033b
ER
498%xmms_prefix %(xmms-config --prefix 2>/dev/null)
499%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
500%xmms_version %(xmms-config --version 2>/dev/null)
501%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
502%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
503%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
504%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
505%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
506%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
507%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
2afc6e64 508
d1537778
PS
509%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
510
848c0d68 511# user/group checking macros
512#
513# Usage:
514# %userremove myuser
515#
516%userremove /usr/lib/rpm/user_group.sh user del
517%groupremove /usr/lib/rpm/user_group.sh group del
518#
519# Usage:
520# if %usertestrm myuser; then
521# /usr/sbin/userdel -r myuser
522# Note:
523# use these macros only if you need to call userdel/groupdel with
524# a non-standard option or take an extra action; otherwise use the
525# %userremove/%groupremove macros
526#
527%usertestrm /usr/lib/rpm/user_group.sh user testrm
528%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
529# user group membership management macros
530#
531# Usage:
532# %addusertogroup myuser agroup
533#
534%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 535
536# banner support (useful in {pre,post}{,un} and triggers)
537#
538# Usage:
aa41c920 539# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 540# the banner text, the banner text
aa41c920
ER
541# the banner text, and following line
542#EOF
543# You can use any form of here-document, <<'EOF' <<-EOT will do.
544# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
545#
72fcfcb3 546# -a - append to the banner
a8b9562a 547# -e - send to stderr instead of stdout
628754cb 548# -n - no show banner (overrides -t)
549# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
aa41c920 550%banner(aent:) \
1b334fe4 551RPM_SCRIPTVERBOSITY=5 \
552[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
553if [ -x /usr/bin/banner.sh ]; then \
aa41c920 554 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 555else \
a8b9562a 556 CMD="cat%{-e: >&2}" \
1b334fe4 557fi \
c2e886e1 558eval $CMD %2%{?3: %3} \
72fcfcb3 559%nil
628754cb 560
90627280
ER
561# useradd/groupadd macros written by glen@pld-linux.org.
562# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
563#
564# Usage:
565# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
566# [-g initial_group] [-G group[,...]] login
567#
568# -u uid. REQUIRED
569# -g gid/group. REQUIRED
570# -s defaults to /bin/false
571# -d defaults to /usr/share/empty
572# -c No default
573# -r is accepted but ignored (it's always set)
6bd4c218 574# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
575# rpm specific flags
576# -P package name. defaults to %{name}
577#
90627280 578%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
579%{!-u:%{error:useradd: Required argument -u missing}} \
580%{!-g:%{error:useradd: Required argument -g missing}} \
581%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
582if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
583 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
584 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
585 exit 1 \
586 fi \
587else \
588 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
589 /usr/sbin/useradd \\\
b5a7d552 590 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
591 -u %{-u*} \\\
592 -r \\\
593 -d %{-d*}%{!-d:/usr/share/empty} \\\
594 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 595 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
596 -g %{-g*} \\\
597 %{-M} \\\
598 %{-G:-G %{-G*}} \\\
840e7b00 599 %{expand:%{%{#}}} 1>&2 \
90627280
ER
600fi;
601
90627280
ER
602# Usage:
603# %groupadd [-P package] [-g gid] group
604#
605# -g gid. REQUIRED
606#
607# Sample:
608# %groupadd -P %{name}-base -g %{gid} %{name}
609
610%groupadd(g:P:rfo) \
9ba02ba9
ER
611%{!-g:%{error:groupadd: Required argument -g missing}} \
612%{!?1:%{error:groupadd: Required parameter group missing}} \
90627280
ER
613if [ -n "`/usr/bin/getgid %{1}`" ]; then \
614 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
615 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
616 exit 1 \
617 fi \
618else \
619 echo "Adding group %{1} GID=%{-g*}." \
840e7b00 620 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
90627280 621fi;
7cb77741
ER
622
623# apache_config_{install/uninstall} macros written by glen@pld-linux.org.
624# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
625#
626# The config is installed/removed inside trigger, this means that you can any
627# time install apache1 or apache package and the configuration file is updated.
628# if you don't need the config for various reason for specific apache, just
629# remove the symlink from apache config directory. the trigger will not put the
630# config again to that version of apache. In other words the config is linked
631# to apache config directory on first install of PACKAGE or apache.
632#
633# should be called in trigger body:
634# %triggerin -- apache1 >= 1.3.33-2
635# %apache_config_install -v 1
636#
637# Add package's apache config to apache config.
638#
639# Usage:
640# %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
641#
642# -v REQUIRED: specify apache version. can be 1 or 2.
643# -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
644# -n OPTIONAL: specify config "slot". defaults to 99
645#
646# Internal macros. don't use ;).
647# expands apache config dir by apache version at build time.
648%__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
649# expands apache service name by apache version at build time.
650%__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
651
652%apache_config_install(v:c:n:) \
653%{!-v:%{error:apache_config_install: Required argument -v missing}} \
654%{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
655if [ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{__apache_confdir %{-v*}} ]; then\
656 ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
657fi\
e5a1a393 658# reload apache if the config symlink is there\
de11f042 659if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
ab251261
ER
660 # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
661 if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
e5a1a393 662 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
7cb77741
ER
663 fi\
664fi\
665%{nil}
666
667# Remove package's apache config from apache config.
668#
669# Usage:
670# %apache_config_uninstall -v {1|2} -n 99
671#
672# -v REQUIRED: specify apache version. can be 1 or 2.
673# -n OPTIONAL: specify config "slot". defaults to 99
674%apache_config_uninstall(v:n:) \
675%{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
676%{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
feb15ceb 677# remove link if either of the packages are gone \
7cb77741
ER
678if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
679 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
680 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
681 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
e5a1a393 682 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
7cb77741
ER
683 fi \
684 fi \
685fi \
686%{nil}
687
d87a3f0b
ER
688# see browser-plugins.spec / template-browser-plugin.spec
689# written by glen@pld-linux.org.
bba6d017 690%nsplugin_install(d:f) { \
d87a3f0b 691# create link if it's first install of either of the packages \
bba6d017 692if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
d87a3f0b
ER
693( \
694%( \
695 for file in %{*}; do \
696 echo echo Installing $file to %{-d*}; \
697 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
698 done ) \
699) | ( %banner -t 5 -e %{name}-in ); fi; \
700}
701
933139a5 702%nsplugin_uninstall(d:) { \
d87a3f0b
ER
703# remove link if either of the packages are gone \
704if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
705( \
706%( \
707 for file in %{*}; do \
708 echo echo Removing $file from %{-d*}; \
709 echo "rm -f %{-d*}/$file;"; \
710 done ) \
711) | ( %banner -t 5 -e %{name}-un ); fi; \
712}
462b26fa
ER
713
714# service macro.
715#
716# calls usual service restart on package %post, but skips the restart if
717# administrator has disabled automatic service restarts in either global
718# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
719#
720# written by glen@pld-linux.org.
721# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
722#
723# Usage:
3e913a30 724# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa
ER
725#
726# -q be silent when service isn't started (for postun scriplets)
727#
e2070050 728%service(q) {{ \
462b26fa
ER
729# we use function, not to globber namespace with useless variables \
730skip_auto_restart() { \
e2070050
ER
731 . /etc/sysconfig/rpm; # global setting \
732 [ -f /etc/sysconfig/%1 ] && . /etc/sysconfig/%1; # per service setting \
733 echo ${RPM_SKIP_AUTO_RESTART:-no}; \
734}; \
462b26fa
ER
735if [ -f /var/lock/subsys/%1 ]; then \
736 if [ $(skip_auto_restart) = no ]; then \
e2070050 737 /etc/rc.d/init.d/%1 %2 1>&2; \
a2629787
ER
738%{!-q:else} \
739 %{!-q:echo 'Run "/etc/rc.d/init.d/%1 %2" to %2 %{!?3:%1 service}%{?3:%(set -- %{*}; echo "$3")}.';} \
462b26fa 740 fi \
3dabcf32 741%{!-q:else} \
3e913a30 742 %{!-q:echo 'Run "/etc/rc.d/init.d/%1 start" to start %{!?3:%1 service}%{?3:%(set -- %{*}; echo "$3")}.';} \
28d8c4be 743fi }; }
462b26fa 744
This page took 0.41605 seconds and 4 git commands to generate.